/*
 * BasicOperations.java
 *
 * Created on 10 September 2008, 15:09
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package GUIComponents;



public class BasicOperations {
    
    /** Creates a new instance of BasicOperations */
    public BasicOperations() {
    }
    private static boolean find(String[] list, String item){
        if(list==null) return false;
        if(item ==null) return false;
        for(int i=0; i<list.length; i++){
            if(list[i].equalsIgnoreCase(item))
                return true;
        }
        return false;
    }
    protected static String[] deleteItem(String[] list, String item){
        if(list==null) return null;
        if(item==null) return list;
        if(list.length==1){
            if(item.equalsIgnoreCase(list[0])) return null;
            else return list;
        }
        else{
            if(BasicOperations.find(list,item)){
                String[] newList = new String[list.length-1];
                int index=0;
                for(int i=0; i<list.length; i++){
                    if(!item.equals(list[i])){
                        newList[index]=list[i];
                        index++;
                    }
                }
                return newList;
            }
            else return list;
        }
    }
        protected static int[] copy(int[] intList){
        if(intList == null) return null;
        int[] newintList = new int[intList.length];
        for (int i=0; i<intList.length; i++ )
            newintList[i]= intList[i];
        return newintList;        
    }   
    /**return a copy of the input Arg Tree nodes List*/
    protected static ArgTreeNode[] copy(ArgTreeNode[] nodeList){
        if(nodeList == null) return null;
        ArgTreeNode[] newNodeList = new ArgTreeNode[nodeList.length];
        for (int i=0; i<nodeList.length; i++ )
            newNodeList[i]= nodeList[i];
        return newNodeList;        
    }
    /**copies a set of moves*/
    protected static Move[] copy(Move[] moveSet) {
        if (moveSet == null) return(null);
	Move[] newMoveSet = new Move[moveSet.length];
	for(int index=0;index<moveSet.length;index++) {
	    newMoveSet[index] = moveSet[index];
	}
	return(newMoveSet);
    }       
    /**copies one move into a set of moves*/
    protected static Move[] copy(Move move){
        if (move == null) return(null);
	Move[] newMoveSet = new Move[1];
	newMoveSet[0]=move;
	return(newMoveSet);
    }
     /**copies a set of shorts*/
    protected static short[] copy(short[] itemSet) {
	if (itemSet == null) return(null);
	short[] newItemSet = new short[itemSet.length];
	for(int index=0;index<itemSet.length;index++) {
	    newItemSet[index] = itemSet[index];
	    }
	return(newItemSet);
	}
    /**copies one PlAYER into a set of PLAYERS*/
    protected static GroupPlayer[] copy(GroupPlayer player){
        if (player == null) return(null);
	GroupPlayer[] newPlayerSet = new GroupPlayer[1];
	newPlayerSet[0]=player;
	return(newPlayerSet);
    }
    /**copies one GROUP into a set of GROUPS*/
    protected static Group[] copy(Group group){
        if (group == null) return(null);
	Group[] newGroupSet = new Group[1];
	newGroupSet[0]=group;
	return(newGroupSet);
    }
    /**copies one TRING into a set of STRINGS*/
    protected static String[] copy(String aString){
        if (aString == null) return(null);
	String[] newStringSet = new String[1];
	newStringSet[0]=aString;
	return(newStringSet);
    }
    /*--------------------------------------------------------------------*/
    //APPEND
    /** appends an integer number to the input integer list*/
    protected static int[] append(int[] intList, int number) {
	if (intList == null) {
            int[] newintList = new int[1];
            newintList[0] = number;
            return newintList;
        }		
	int[] newintList = new int[intList.length + 1];
	for(int i=0;i<intList.length;i++)
	    newintList[i]=intList[i];
        newintList[intList.length] = number;
	return(newintList);	
    }
    /** appends arguementation tree node list nodelist2 to the end of nodelist1*/
    protected static ArgTreeNode[] append(ArgTreeNode[] nodeList1, ArgTreeNode[] nodeList2){
 	if (nodeList1 == null) return(copy(nodeList2));
	else if (nodeList2 == null) return(copy(nodeList1));
	ArgTreeNode[] newNodeList = new ArgTreeNode[nodeList1.length + nodeList2.length];
	int index1;
	for(index1=0;index1<nodeList1.length;index1++)
	    newNodeList[index1]=nodeList1[index1];	    
	for(int index2=0;index2<nodeList2.length;index2++)
	    newNodeList[index1+index2]=nodeList2[index2];
	return(newNodeList);	
    }   
    /** appends arguementation tree node to the end of nodelist*/
    protected static ArgTreeNode[] append(ArgTreeNode[] nodeList, ArgTreeNode node){
	if (nodeList == null) {
            ArgTreeNode[] newNodeList = new ArgTreeNode[1];
            newNodeList[0] = node;
            return newNodeList;
        }
	else if (node == null) return(copy(nodeList));		
	ArgTreeNode[] newNodeList = new ArgTreeNode[nodeList.length + 1];
	for(int i=0;i<nodeList.length;i++)
	    newNodeList[i]=nodeList[i];
        newNodeList[nodeList.length] = node;
	return(newNodeList);	
    }   
    /**appends a new move to a set of moves*/
    protected static Move[] append(Move[] moveSet, Move move) {
         if (moveSet == null) return(copy(move));	
         else if (move == null) return(copy(moveSet));
         Move[] newMoveSet = new Move[moveSet.length+1];
         int index;
         for(index=0;index<moveSet.length;index++)
             newMoveSet[index]=moveSet[index];	    
         newMoveSet[moveSet.length] = move;
         return(newMoveSet);	
     }  
    /**appends a set of moves 'moveSet2' to another set of moves 'moveSet1'*/
    protected static Move[] append(Move[] moveSet1, Move[] moveSet2) {
	if (moveSet1 == null) return(copy(moveSet2));
        if (moveSet2 == null) return(copy(moveSet1));	
	Move[] newMoveSet = new Move[moveSet1.length+moveSet2.length];
	int index;
	for(index=0;index<moveSet1.length;index++) newMoveSet[index]=moveSet1[index];	    
        for(int index2=0; index2<moveSet2.length;index2++)  newMoveSet[index+index2]=moveSet2[index2];   
	return(newMoveSet);	
     }
    /**appends a set of moves 'moves' to an 2D array of moves moveSet*/
    protected static Move[][] append(Move[][] moveSet, Move[] moves) {
        //if(moves==null) return moveSet;        
        if(moveSet==null) {
            Move[][] newMoveSet = new Move[1][];            
            if(moves==null){
                newMoveSet[0]=null;
            }
            else{
                newMoveSet[0] = new Move[moves.length];
                for(int i=0; i<moves.length; i++){
                    newMoveSet[0][i] = moves[i];
                }
            }
            return newMoveSet;
        }
        else{
            Move[][] newMoveSet = new Move[moveSet.length+1][];
            for(int i=0; i<moveSet.length; i++){
                if(moveSet[i]==null)
                    newMoveSet[i] =null;
                else{
                    newMoveSet[i] = new Move[moveSet[i].length];
                    for(int j=0; j<moveSet[i].length; j++){
                       newMoveSet[i][j] = moveSet[i][j]; 
                    }
                }
            }            
            if(moves==null){
                newMoveSet[moveSet.length]=null;
            }
            else{
                newMoveSet[moveSet.length] = new Move[moves.length];
                for(int i=0; i<moves.length; i++){
                    newMoveSet[moveSet.length][i] = moves[i];
                }
            }
            return newMoveSet;
        }
     }
        /**appends one move to an 2D array of moves moveSet*/
    protected static Move[][] append(Move[][] moveSet, Move move) {             
        if(moveSet==null) {
            Move[][] newMoveSet = new Move[1][];
            newMoveSet[0] = new Move[1];
            if(move==null)
                newMoveSet[0] = null;            
            else    
                newMoveSet[0][0] = move;
            return newMoveSet;
        }
        else{
            Move[][] newMoveSet = new Move[moveSet.length+1][];
            for(int i=0; i<moveSet.length; i++){
                if(moveSet[i]==null)
                    newMoveSet[i] =null;
                else{
                    newMoveSet[i] = new Move[moveSet[i].length];
                    for(int j=0; j<moveSet[i].length; j++){
                       newMoveSet[i][j] = moveSet[i][j]; 
                    }
                }
            }
            
            if(move==null)
                newMoveSet[moveSet.length] = null;
            else{
                newMoveSet[moveSet.length] = new Move[1];
                newMoveSet[moveSet.length][0] = move;                
            }
            return newMoveSet;
        }
     }
    
     /**appends a set of moves 'moves' to an 2D array of moves moveSet*/
    protected static InGroupMove[][] append(InGroupMove[][] moveSet, InGroupMove[] moves) {
        //if(moves==null) return moveSet;        
        if(moveSet==null) {
            InGroupMove[][] newMoveSet = new InGroupMove[1][];            
            if(moves==null){
                newMoveSet[0]=null;
            }
            else{
                newMoveSet[0] = new InGroupMove[moves.length];
                for(int i=0; i<moves.length; i++){
                    newMoveSet[0][i] = moves[i];
                }
            }
            return newMoveSet;
        }
        else{
            InGroupMove[][] newMoveSet = new InGroupMove[moveSet.length+1][];
            for(int i=0; i<moveSet.length; i++){
                if(moveSet[i]==null)
                    newMoveSet[i] =null;
                else{
                    newMoveSet[i] = new InGroupMove[moveSet[i].length];
                    for(int j=0; j<moveSet[i].length; j++){
                       newMoveSet[i][j] = moveSet[i][j]; 
                    }
                }
            }            
            if(moves==null){
                newMoveSet[moveSet.length]=null;
            }
            else{
                newMoveSet[moveSet.length] = new InGroupMove[moves.length];
                for(int i=0; i<moves.length; i++){
                    newMoveSet[moveSet.length][i] = moves[i];
                }
            }
            return newMoveSet;
        }
     }
        /**appends one move to an 2D array of moves moveSet*/
    protected static InGroupMove[][] append(InGroupMove[][] moveSet, InGroupMove move) {             
        if(moveSet==null) {
            InGroupMove[][] newMoveSet = new InGroupMove[1][];
            newMoveSet[0] = new InGroupMove[1];
            if(move==null)
                newMoveSet[0] = null;            
            else    
                newMoveSet[0][0] = move;
            return newMoveSet;
        }
        else{
            InGroupMove[][] newMoveSet = new InGroupMove[moveSet.length+1][];
            for(int i=0; i<moveSet.length; i++){
                if(moveSet[i]==null)
                    newMoveSet[i] =null;
                else{
                    newMoveSet[i] = new InGroupMove[moveSet[i].length];
                    for(int j=0; j<moveSet[i].length; j++){
                       newMoveSet[i][j] = moveSet[i][j]; 
                    }
                }
            }
            newMoveSet[moveSet.length] = new InGroupMove[1];
            if(move==null)
                newMoveSet[moveSet.length] = null;
            else
                newMoveSet[moveSet.length][0] = move;
            return newMoveSet;
        }
     }
    
    /**appends a new PLAYER to a set of PLAYERs*/
    protected static GroupPlayer[] append(GroupPlayer[] playersSet, GroupPlayer player) {
         if (playersSet == null) return(copy(player));	
         else if (player == null) return playersSet;
         GroupPlayer[] newPlayersSet = new GroupPlayer[playersSet.length+1];
         for(int index=0;index<playersSet.length;index++)
             newPlayersSet[index]=playersSet[index];	    
         newPlayersSet[playersSet.length] = player;
         return(newPlayersSet);	
     }  
    /**appends a new Group to a set of GROUPS*/
    protected static Group[] append(Group[] groupsSet, Group group) {
         if (groupsSet == null) return(copy(group));	
         else if (group == null) return groupsSet;
         Group[] newGroupsSet = new Group[groupsSet.length+1];
         for(int index=0;index<groupsSet.length;index++)
             newGroupsSet[index]=groupsSet[index];	    
         newGroupsSet[groupsSet.length] = group;
         return(newGroupsSet);	
     }  
    /**appends a new String to a set of Strings*/
    protected static String[] append(String[] stringsSet, String newString) {
         if (stringsSet == null) return(copy(newString));	
         else if (newString == null) return stringsSet;
         String[] newStringsSet = new String[stringsSet.length+1];
         for(int index=0;index<stringsSet.length;index++)
             newStringsSet[index]=stringsSet[index];	    
         newStringsSet[stringsSet.length] = newString;
         return(newStringsSet);	
     } 
    /**appends short list 2 to 1*/
    protected static short[] append(short[] itemSet1, short[] itemSet2) {
	if (itemSet1 == null) return(copy(itemSet2));
	else if (itemSet2 == null) return(copy(itemSet1));
	short[] newItemSet = new short[itemSet1.length+itemSet2.length];
	int index1;
	for(index1=0;index1<itemSet1.length;index1++) {
	    newItemSet[index1]=itemSet1[index1];
	    }
	for(int index2=0;index2<itemSet2.length;index2++) {
	    newItemSet[index1+index2]=itemSet2[index2];
	    }
	return(newItemSet);	
        }
    /**appends string list 2 to 1*/
    protected static String[] append(String[] stringSet1, String[] stringSet2) {
	if (stringSet2 == null) return stringSet1;
	else if (stringSet1 == null) return stringSet2;
	String[] newStringSet = new String[stringSet1.length+stringSet2.length];
	int index1;
	for(index1=0;index1<stringSet1.length;index1++) {
	    newStringSet[index1]=stringSet1[index1];
	    }
	for(int index2=0;index2<stringSet2.length;index2++) {
	    newStringSet[index1+index2]=stringSet2[index2];
	    }
	return(newStringSet);	
        }
	
}
