/*
 * GameDictionaryFilter.java
 *
 * Created on 09 September 2008, 18:05
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package GUIComponents;

//java packages
import java.io.File;
import javax.swing.*;
import javax.swing.filechooser.*;


public class PISAFilter extends FileFilter {
    String validExtension="gmd";
    /**accept files .gd only*/
    private String getExtension(File f) {
        String ext = null;
        String s = f.getName();
        int i = s.lastIndexOf('.');

        if (i > 0 &&  i < s.length() - 1) {
            ext = s.substring(i+1).toLowerCase();
        }
        return ext;
    }       
    public boolean accept(File f) {
        if (f.isDirectory()) return false;
        String extension = this.getExtension(f);
        if (extension != null) {
            if (extension.equalsIgnoreCase(validExtension)){
                return true;}
            else    return false;            
        }
        return false;
    }

    //The description of this filter
    public String getDescription() {
        if (this.validExtension.equalsIgnoreCase("gmd"))
        return "Just Game Dictionary";
        else return "Just Numerical Files";
    }
    public void setValidExtension(String ext){
        this.validExtension = ext;
    }

}
