/*
 * Colours.java
 *
 * Created on 02 September 2008, 11:34
 *
 * Encapuslates the basic Argumentation Tree Colours (Green, Red, Blue and Purple) 
 * and the operations on these colours
 * @author maya
 */

package GUIComponents;

public final class Colours {
   //the basic colours in the argumentation tree    
    protected static final int RED =1; //means that the move node is directly defeated at the moment 
    protected static final int BLUE =2; //means that the  node is a vaild 2 or 3 move node  
    protected static final int GREEN =3; //means that the  node is a vaild 1,4,5 or 6 move node
    protected static final int PURPLE =4; //means that the move node is indirectly defeated at the moment 
   
    /**Translates the colour code into string*/
    protected static String translate(int colour){        
        switch(colour){
            case 1:
                return "RED";
            case 2:
                return "BLUE";
            case 3:
                return "GREEN";
            case 4:     
                 return "PURPLE";
            default:
                return "INVAILD COLOUR VALUE";
        }     
    }   
    /**return true if the colour integer value is valid, false other wise*/
    protected static boolean vaildColour(int colour){        
        switch(colour){
            case 1: case 2:case 3: case 4:
                return true;
            default:
                return false;
        }     
    }
}
