/*
 * DMU.java
 *
 * Created on 03 September 2008, 15:30
 *
 * Dialogue Management Unit, most of the functionality has been transfered to the chairPerson
 *
 * @author maya
 */

package GUIComponents;

public class DMU {
    
    int roundCounter; //counts the game rounds
    int maxNoRounds;  //the maximum number of rounds allowed per game
    
    /** Creates a new instance of DMU */
    public DMU(int maxNoRounds) {
        this.roundCounter=0;
        this.maxNoRounds =maxNoRounds; 
    }
    
    /*Getters & Setter*/
    public int getRoundCounter() {return this.roundCounter;}
    public int getMaxNoRounds(){return this.maxNoRounds;}
    public void setMaxNoRounds(int newMaxNoRounds){this.maxNoRounds = newMaxNoRounds;}
    /**starts a new round*/
    public boolean startNewRound(){
        if (this.roundCounter<this.maxNoRounds){
            this.roundCounter+=1;
            return true;
        }
        else
            return false;
    }
    /**reset round counter*/
    private void resetCounter(){this.roundCounter=0;}
    /**initialize the unit*/
    public void initialize(){this.resetCounter();}
}
